diff --git a/bwb_inp.c b/bwb_inp.c
index bd70c0c..20b5919 100644
--- a/bwb_inp.c
+++ b/bwb_inp.c
@@ -29,6 +29,11 @@
 
 ***************************************************************/
 
+/*---------------------------------------------------------------*/
+/* NOTE: Modifications marked "JBV" were made by Jon B. Volkoff, */
+/* 11/1995 (eidetics@cerf.net).                                  */
+/*---------------------------------------------------------------*/
+
 #include <stdio.h>
 #include <ctype.h>
 #include <math.h>
@@ -47,6 +52,7 @@ static int inp_assign( char *b, struct bwb_variable *v );
 static int inp_advws( FILE *f );
 static int inp_xgetc( FILE *f, int is_string );
 static int inp_eatcomma( FILE *f );
+static bnumber inp_numconst( char *expression ); /* JBV */
 #else
 static struct bwb_line *bwb_xinp();
 static struct bwb_line *inp_str();
@@ -55,10 +61,12 @@ static int inp_assign();
 static int inp_advws();
 static int inp_xgetc();
 static int inp_eatcomma();
+static bnumber inp_numconst(); /* JBV */
 #endif
 
 static char_saved = FALSE;
 static cs;
+static int last_inp_adv_rval = FALSE; /* JBV */
 
 /***************************************************************
 
@@ -621,7 +629,15 @@ bwb_input( l )
 
       /* advance past semicolon to beginning of variable */
 
-      suppress_qm = inp_adv( l->buffer, &( l->position ) );
+      /*--------------------------------------------------------*/
+      /* Since inp_const was just called and inp_adv is called  */
+      /* within that, it will have already noted and passed the */
+      /* comma by the time it gets here.  Therefore one must    */
+      /* refer instead to the last returned value for inp_adv!  */
+      /* (JBV, 10/95)                                           */
+      /*--------------------------------------------------------*/
+      /* suppress_qm = inp_adv( l->buffer, &( l->position ) ); */
+      suppress_qm = last_inp_adv_rval;
 
       /* print the prompt string */
 
@@ -772,7 +788,12 @@ bwb_xinp( l, f )
                tbuf );
             bwb_debug( bwb_ebuf );
 #endif
-            * var_findnval( v, v->array_pos ) = (bnumber) atof( tbuf );
+            /*------------------------------------------------------------*/
+            /* atof call replaced by inp_numconst, gets all input formats */
+            /* (JBV, 10/95)                                               */
+            /*------------------------------------------------------------*/
+            /* * var_findnval( v, v->array_pos ) = (bnumber) atof( tbuf ); */
+            * var_findnval( v, v->array_pos ) = inp_numconst( tbuf );
             break;
          }				/* end of switch for type-specific input */
 
@@ -801,7 +822,7 @@ bwb_xinp( l, f )
         FUNCTION:       inp_advws()
 
 	DESCRIPTION:    This C function advances past whitespace
-			inoput from a particular file or device.
+			input from a particular file or device.
 
 ***************************************************************/
 
@@ -1118,7 +1139,12 @@ inp_assign( b, v )
             }
          else
             {
-            *( var_findnval( v, v->array_pos )) = (bnumber) atof( b );
+            /*------------------------------------------------------------*/
+            /* atof call replaced by inp_numconst, gets all input formats */
+            /* (JBV, 10/95)                                               */
+            /*------------------------------------------------------------*/
+            /* *( var_findnval( v, v->array_pos )) = (bnumber) atof( b ); */
+            *( var_findnval( v, v->array_pos )) = inp_numconst( b );
             }
          break;
 
@@ -1178,8 +1204,10 @@ inp_adv( b, c )
          case '\0':		/* end of line */
          case ':': 		/* end of line segment */
             rval = TRUE;
+            last_inp_adv_rval = rval; /* JBV */
             return rval;
          default:
+            last_inp_adv_rval = rval; /* JBV */
             return rval;
          }
       }
@@ -1318,6 +1346,8 @@ bwb_line( l )
    FILE *inp_device;
    char tbuf[ MAXSTRINGSIZE + 1 ];
    char pstring[ MAXSTRINGSIZE + 1 ];
+   struct exp_ese *e; /* JBV */
+   int pos; /* JBV */
 
    /* assign default values */
 
@@ -1351,7 +1381,10 @@ bwb_line( l )
       ++l->position;
       adv_element( l->buffer, &( l->position ), tbuf );
       adv_ws( l->buffer, &( l->position ));
-      dev_no = atoi( tbuf );
+      /* dev_no = atoi( tbuf ); */  /* We really need more, added next (JBV) */
+      pos = 0;
+      e = bwb_exp( tbuf, FALSE, &pos );
+      dev_no = (int) exp_getnval( e );
 
 #if INTENSIVE_DEBUG
       sprintf( bwb_ebuf, "in bwb_line(): file number requested <%d>", dev_no );
@@ -1437,4 +1470,446 @@ bwb_line( l )
 
 #endif				/* COMMON_CMDS */
 
-
\ No newline at end of file
+/***************************************************************
+
+        FUNCTION:	inp_numconst()
+
+        DESCRIPTION:	This function interprets a numerical
+			constant.  Added by JBV 10/95
+
+***************************************************************/
+
+#if ANSI_C
+bnumber
+inp_numconst( char *expression )
+#else
+bnumber
+inp_numconst( expression )
+   char *expression;
+#endif
+   {
+   int base;                            /* numerical base for the constant */
+   static struct bwb_variable mantissa; /* mantissa of floating-point number */
+   static int init = FALSE;		/* is mantissa variable initialized? */
+   int exponent;                        /* exponent for floating point number */
+   int man_start;                       /* starting point of mantissa */
+   int s_pos;                           /* position in build string */
+   int build_loop;
+   int need_pm;
+   int i;
+   bnumber d;
+
+   /* Expression stack stuff */
+   char type;
+   bnumber nval;
+   char string[ MAXSTRINGSIZE + 1 ];
+   int pos_adv;
+
+   /* initialize the variable if necessary */
+
+#if INTENSIVE_DEBUG
+   strcpy( mantissa.name, "(mantissa)" );
+#endif
+
+   if ( init == FALSE )
+      {
+      init = TRUE;
+      var_make( &mantissa, NUMBER );
+      }
+
+   /* be sure that the array_pos[ 0 ] for mantissa is set to dim_base;
+      this is necessary because mantissa might be used before dim_base
+      is set */
+
+   mantissa.array_pos[ 0 ] = dim_base;
+
+#if INTENSIVE_DEBUG
+   sprintf( bwb_ebuf, "in inp_numconst(): received <%s>, eval <%c>",
+      expression, expression[ 0 ] );
+   bwb_debug( bwb_ebuf );
+#endif
+
+   need_pm = FALSE;
+   nval = (bnumber) 0;
+
+   /* check the first character(s) to determine numerical base
+      and starting point of the mantissa */
+
+   switch( expression[ 0 ] )
+      {
+      case '-':
+      case '+':
+      case '0':
+      case '1':
+      case '2':
+      case '3':
+      case '4':
+      case '5':
+      case '6':
+      case '7':
+      case '8':
+      case '9':
+      case '.':
+         base = 10;                     /* decimal constant */
+	 man_start = 0;                 /* starts at position 0 */
+	 need_pm = FALSE;
+         break;
+      case '&':                         /* hex or octal constant */
+         if ( ( expression[ 1 ] == 'H' ) || ( expression[ 1 ] == 'h' ))
+            {
+            base = 16;                  /* hexadecimal constant */
+            man_start = 2;              /* starts at position 2 */
+            }
+         else
+            {
+            base = 8;                   /* octal constant */
+            if ( ( expression[ 1 ] == 'O' ) || ( expression[ 1 ] == 'o' ))
+               {
+               man_start = 2;           /* starts at position 2 */
+               }
+            else
+               {
+               man_start = 1;           /* starts at position 1 */
+               }
+            }
+         break;
+      default:
+
+#if PROG_ERRORS
+         sprintf( bwb_ebuf, "expression <%s> is not a numerical constant.",
+            expression );
+         bwb_error( bwb_ebuf );
+#else
+         bwb_error( err_syntax );
+#endif
+         return (bnumber) 0;
+      }
+
+   /* now build the mantissa according to the numerical base */
+
+   switch( base )
+      {
+
+      case 10:                          /* decimal constant */
+
+         /* initialize counters */
+
+         pos_adv = man_start;
+         type = NUMBER;
+         string[ 0 ] = '\0';
+         s_pos = 0;
+         exponent = 0;
+         build_loop = TRUE;
+
+         /* loop to build the string */
+
+         while ( build_loop == TRUE )
+            {
+            switch( expression[ pos_adv ] )
+               {
+               case '-':                        /* prefixed plus or minus */
+               case '+':
+
+                  /* in the first position, a plus or minus sign can
+                     be added to the beginning of the string to be
+                     scanned */
+
+                  if ( pos_adv == man_start )
+                     {
+                     string[ s_pos ] = expression[ pos_adv ];
+                     ++pos_adv;  /* advance to next character */
+                     ++s_pos;
+                     string[ s_pos ] = '\0';
+                     }
+
+                  /* but in any other position, the plus or minus sign
+                     must be taken as an operator and thus as terminating
+                     the string to be scanned */
+
+                  else
+                     {
+                     build_loop = FALSE;
+                     }
+                  break;
+               case '.':                        /* note at least single precision */
+               case '0':                        /* or ordinary digit */
+               case '1':
+               case '2':
+               case '3':
+               case '4':
+               case '5':
+               case '6':
+               case '7':
+               case '8':
+               case '9':
+                  string[ s_pos ] = expression[ pos_adv ];
+                  ++pos_adv;  /* advance to next character */
+                  ++s_pos;
+                  string[ s_pos ] = '\0';
+                  break;
+
+	       case '#':                        /* Microsoft-type precision indicator; ignored but terminates */
+	       case '!':                        /* Microsoft-type precision indicator; ignored but terminates */
+		  ++pos_adv;  /* advance to next character */
+		  type = NUMBER;
+		  exponent = FALSE;
+		  build_loop = FALSE;
+		  break;
+
+	       case 'E':                        /* exponential, single precision */
+               case 'e':
+                  ++pos_adv;  /* advance to next character */
+                  type = NUMBER;
+		  exponent = TRUE;
+                  build_loop = FALSE;
+		  break;
+
+               case 'D':                        /* exponential, double precision */
+               case 'd':
+                  ++pos_adv;  /* advance to next character */
+                  type = NUMBER;
+		  exponent = TRUE;
+                  build_loop = FALSE;
+                  break;
+
+               default:                         /* anything else, terminate */
+                  build_loop = FALSE;
+                  break;
+               }
+
+            }
+
+         /* assign the value to the mantissa variable */
+         
+#if NUMBER_DOUBLE
+         sscanf( string, "%lf", var_findnval( &mantissa, mantissa.array_pos ));
+#else
+         sscanf( string, "%f", var_findnval( &mantissa, mantissa.array_pos ));
+#endif
+
+#if INTENSIVE_DEBUG
+         sprintf( bwb_ebuf, "in inp_numconst(): read mantissa, string <%s> val <%lf>",
+            string, var_getnval( &mantissa ) );
+         bwb_debug( bwb_ebuf );
+#endif
+
+         /* test if integer bounds have been exceeded */
+
+         if ( type == NUMBER )
+            {
+            i = (int) var_getnval( &mantissa );
+            d = (bnumber) i;
+            if ( d != var_getnval( &mantissa ))
+               {
+               type = NUMBER;
+#if INTENSIVE_DEBUG
+               sprintf( bwb_ebuf, "in inp_numconst(): integer bounds violated, promote to NUMBER" );
+               bwb_debug( bwb_ebuf );
+#endif               
+               }
+            }
+
+         /* read the exponent if there is one */
+
+         if ( exponent == TRUE )
+            {
+
+	    /* allow a plus or minus once at the beginning */
+
+	    need_pm = TRUE;
+
+	    /* initialize counters */
+
+            string[ 0 ] = '\0';
+            s_pos = 0;
+            build_loop = TRUE;
+
+            /* loop to build the string */
+
+            while ( build_loop == TRUE )
+               {
+               switch( expression[ pos_adv ] )
+                  {
+		  case '-':                        /* prefixed plus or minus */
+                  case '+':
+
+		     if ( need_pm == TRUE )        /* only allow once */
+			{
+			string[ s_pos ] = expression[ pos_adv ];
+			++pos_adv;  /* advance to next character */
+			++s_pos;
+			string[ s_pos ] = '\0';
+			}
+		     else
+			{
+			build_loop = FALSE;
+			}
+		     break;
+
+		  case '0':                        /* or ordinary digit */
+                  case '1':
+                  case '2':
+                  case '3':
+                  case '4':
+                  case '5':
+                  case '6':
+                  case '7':
+                  case '8':
+                  case '9':
+
+                     string[ s_pos ] = expression[ pos_adv ];
+                     ++pos_adv;  /* advance to next character */
+                     ++s_pos;
+		     string[ s_pos ] = '\0';
+		     need_pm = FALSE;
+                     break;
+
+                  default:                         /* anything else, terminate */
+                     build_loop = FALSE;
+                     break;
+                  }
+
+               }                                /* end of build loop for exponent */
+
+            /* assign the value to the user variable */
+
+#if NUMBER_DOUBLE
+            sscanf( string, "%lf", &nval );
+#else
+            sscanf( string, "%f", &nval );
+#endif
+
+#if INTENSIVE_DEBUG
+	    sprintf( bwb_ebuf, "in inp_numconst(): exponent is <%d>",
+               (int) nval );
+            bwb_debug( bwb_ebuf );
+#endif
+
+            }                           /* end of exponent search */
+
+         if ( nval == (bnumber) 0 )
+            {
+            nval = var_getnval( &mantissa );
+            }
+         else
+            {
+            nval = var_getnval( &mantissa )
+               * pow( (bnumber) 10.0, (bnumber) nval );
+            }
+
+         break;
+
+      case 8:                           /* octal constant */
+
+         /* initialize counters */
+
+         pos_adv = man_start;
+         type = NUMBER;
+         string[ 0 ] = '\0';
+         s_pos = 0;
+         exponent = 0;
+         build_loop = TRUE;
+
+         /* loop to build the string */
+
+         while ( build_loop == TRUE )
+            {
+            switch( expression[ pos_adv ] )
+               {
+               case '0':                        /* or ordinary digit */
+               case '1':
+               case '2':
+               case '3':
+               case '4':
+               case '5':
+               case '6':
+               case '7':
+                  string[ s_pos ] = expression[ pos_adv ];
+                  ++pos_adv;  /* advance to next character */
+                  ++s_pos;
+                  string[ s_pos ] = '\0';
+                  break;
+
+               default:                         /* anything else, terminate */
+                  build_loop = FALSE;
+                  break;
+               }
+
+            }
+
+         /* now scan the string to determine the number */
+
+         sscanf( string, "%o", &i );
+         nval = (bnumber) i;
+
+         break;
+
+      case 16:                          /* hexadecimal constant */
+
+         /* initialize counters */
+
+         pos_adv = man_start;
+         type = NUMBER;
+         string[ 0 ] = '\0';
+         s_pos = 0;
+         exponent = 0;
+         build_loop = TRUE;
+
+         /* loop to build the string */
+
+         while ( build_loop == TRUE )
+            {
+            switch( expression[ pos_adv ] )
+               {
+               case '0':                        /* or ordinary digit */
+               case '1':
+               case '2':
+               case '3':
+               case '4':
+               case '5':
+               case '6':
+               case '7':
+               case '8':
+               case '9':
+               case 'A':
+               case 'a':
+               case 'B':
+               case 'b':
+               case 'C':
+               case 'c':
+               case 'D':
+               case 'd':
+               case 'E':
+               case 'e':
+               case 'F': /* Don't forget these! (JBV) */
+               case 'f':
+                  string[ s_pos ] = expression[ pos_adv ];
+
+                  ++pos_adv;  /* advance to next character */
+                  ++s_pos;
+                  string[ s_pos ] = '\0';
+                  break;
+
+               default:                         /* anything else, terminate */
+                  build_loop = FALSE;
+                  break;
+               }
+
+            }
+
+         /* now scan the string to determine the number */
+
+         sscanf( string, "%x", &i );
+         nval = (bnumber) i;
+         break;
+      }
+
+#if INTENSIVE_DEBUG
+   sprintf( bwb_ebuf, "in inp_numconst(): precision <%c> value <%lf>",
+      type, nval );
+   bwb_debug( bwb_ebuf );
+#endif
+
+   return nval;
+
+   }
diff --git a/bwb_int.c b/bwb_int.c
index e81396d..5c44451 100644
--- a/bwb_int.c
+++ b/bwb_int.c
@@ -23,6 +23,14 @@
 
 ***************************************************************/
 
+/*---------------------------------------------------------------*/
+/* NOTE: Modifications marked "JBV" were made by Jon B. Volkoff, */
+/* 11/1995 (eidetics@cerf.net).                                  */
+/*                                                               */
+/* Those additionally marked with "DD" were at the suggestion of */
+/* Dale DePriest (daled@cadence.com).                            */
+/*---------------------------------------------------------------*/
+
 #include <stdio.h>
 #include <ctype.h>
 
@@ -85,7 +93,7 @@ adv_element( buffer, pos, element )
          case '=':
          case ' ':
          case '\t':
-         case '\0':
+         /* case '\0': */ /* Removed by JBV (found by DD) */
          case '\n':
          case '\r':
             if ( str_const == TRUE )
@@ -101,6 +109,15 @@ adv_element( buffer, pos, element )
                }
             break;
 
+         case '\0':                     /* Added by JBV (found by DD) */
+            if ( str_const == TRUE )    /* termination of string constant */
+               {
+               element[ e_pos ] = '\"';
+               element[ ++e_pos ] = '\0';
+               }
+            return TRUE;
+            break;
+
          case '\"':                     /* string constant */
             element[ e_pos ] = buffer[ *pos ];
             ++e_pos;
@@ -328,7 +345,9 @@ line_start( buffer, pos, lnpos, lnum, cmdpos, cmdnum, startpos )
    if ( init == FALSE )
       {
       init = TRUE;
-      if ( ( tbuf = calloc( MAXSTRINGSIZE + 1, sizeof( char ) )) == NULL )
+
+      /* Revised to CALLOC pass-thru call by JBV */
+      if ( ( tbuf = CALLOC( MAXSTRINGSIZE + 1, sizeof( char ), "line_start")) == NULL )
          {
 #if PROG_ERRORS
 	 bwb_error( "in line_start(): failed to get memory for tbuf" );
@@ -736,7 +755,9 @@ bwb_numseq( buffer, start, end )
    if ( init == FALSE )
       {
       init = TRUE;
-      if ( ( tbuf = calloc( MAXSTRINGSIZE + 1, sizeof( char ) )) == NULL )
+
+      /* Revised to CALLOC pass-thru call by JBV */
+      if ( ( tbuf = CALLOC( MAXSTRINGSIZE + 1, sizeof( char ), "bwb_numseq")) == NULL )
          {
 #if PROG_ERRORS
 	 bwb_error( "in bwb_numseq(): failed to find memory for tbuf" );
@@ -867,7 +888,14 @@ bwb_freeline( l )
 
    /* free arguments if there are any */
 
-   free( l );
+   /* Revised to FREE pass-thru calls by JBV */
+   if (l->buffer != NULL)
+   {
+       FREE( l->buffer, "bwb_freeline" );
+       l->buffer = NULL; /* JBV */
+   }
+   FREE( l, "bwb_freeline" );
+   l = NULL; /* JBV */
 
    return TRUE;
    }
@@ -952,4 +980,3 @@ is_eol( buffer, position )
 
    }
 
-
\ No newline at end of file
diff --git a/bwb_mes.h b/bwb_mes.h
index fcaba1f..f8f5903 100644
--- a/bwb_mes.h
+++ b/bwb_mes.h
@@ -23,6 +23,10 @@
 
 ***************************************************************/
 
+/*---------------------------------------------------------------*/
+/* NOTE: Modifications marked "JBV" were made by Jon B. Volkoff, */
+/* 11/1995 (eidetics@cerf.net).                                  */
+/*---------------------------------------------------------------*/
 
 #ifndef TRUE
 #define TRUE    1
@@ -391,6 +395,7 @@
 #define CMD_DEFINT	"DEFINT"
 #define CMD_DEFSNG	"DEFSNG"
 #define CMD_DEFSTR	"DEFSTR"
+#define CMD_MID		"MID$"
 #define CMD_CALL	"CALL"
 #define CMD_SUB		"SUB"
 #define CMD_FUNCTION	"FUNCTION"
@@ -409,6 +414,7 @@
 #define CMD_RANDOMIZE	"RANDOMIZE"
 #define CMD_FILES	"FILES"
 #define CMD_EDIT	"EDIT"
+#define CMD_RENUM	"RENUM"
 #define CMD_ERASE	"ERASE"
 #define CMD_SWAP	"SWAP"
 #define CMD_NAME	"NAME"
@@ -471,4 +477,3 @@ extern char err_noprogfile[];
 
 
 
-
\ No newline at end of file
diff --git a/bwb_mth.c b/bwb_mth.c
index 7df2c88..e3aac97 100644
--- a/bwb_mth.c
+++ b/bwb_mth.c
@@ -23,6 +23,11 @@
 
 ****************************************************************/
 
+/*---------------------------------------------------------------*/
+/* NOTE: Modifications marked "JBV" were made by Jon B. Volkoff, */
+/* 11/1995 (eidetics@cerf.net).                                  */
+/*---------------------------------------------------------------*/
+
 #include <stdio.h>
 #include <ctype.h>
 #include <math.h>
@@ -154,8 +159,9 @@ fnc_core( argc, argv, unique_id  )
    switch( unique_id )
       {
       case F_ABS:
+         /* Added double recast here (JBV) */
 	 * var_findnval( &nvar, nvar.array_pos ) =
-	    (bnumber) fabs( var_getnval( &( argv[ 0 ] ) ) );
+	    (bnumber) fabs( (double) var_getnval( &( argv[ 0 ] ) ) );
 	 break;
       case F_ATN:
 	 * var_findnval( &nvar, nvar.array_pos )
@@ -166,8 +172,9 @@ fnc_core( argc, argv, unique_id  )
 	    = (bnumber) cos( (double) var_getnval( &( argv[ 0 ] ) ) );
 	 break;
       case F_EXP:
+         /* Added double recast here (JBV) */
 	 * var_findnval( &nvar, nvar.array_pos )
-	    = (bnumber) exp( var_getnval( &( argv[ 0 ] ) ) );
+	    = (bnumber) exp( (double) var_getnval( &( argv[ 0 ] ) ) );
 	 break;
       case F_INT:
 	 * var_findnval( &nvar, nvar.array_pos )
@@ -178,7 +185,9 @@ fnc_core( argc, argv, unique_id  )
 	    = (bnumber) log( (double) var_getnval( &( argv[ 0 ] ) ) );
 	 break;
       case F_RND:
-	 * var_findnval( &nvar, nvar.array_pos ) = (float) rand() / RAND_MAX;
+         /* Added bnumber recast here (JBV) */
+	 * var_findnval( &nvar, nvar.array_pos )
+	    = (bnumber) ( (float) rand() / RAND_MAX );
 	 break;
       case F_SGN:
 	 nval = var_getnval( &( argv[ 0 ] ));
@@ -296,8 +305,9 @@ fnc_abs( argc, argv, unique_id  )
    bwb_debug( bwb_ebuf );
 #endif
 
+   /* Added double recast here (JBV) */
    * var_findnval( &nvar, nvar.array_pos ) = 
-      (bnumber) fabs( var_getnval( &( argv[ 0 ] ) ) );
+      (bnumber) fabs( (double) var_getnval( &( argv[ 0 ] ) ) );
 
    return &nvar;
 
@@ -339,7 +349,9 @@ fnc_rnd( argc, argv, unique_id  )
       var_make( &nvar, NUMBER );
       }
 
-   * var_findnval( &nvar, nvar.array_pos ) = (float) rand() / RAND_MAX;
+   /* Added bnumber recast here (JBV) */
+   * var_findnval( &nvar, nvar.array_pos )
+      = (bnumber) ( (float) rand() / RAND_MAX );
 
    return &nvar;
    }
@@ -987,8 +999,9 @@ fnc_exp( argc, argv, unique_id )
 
    /* assign values */
 
+   /* Added double recast here (JBV) */
    * var_findnval( &nvar, nvar.array_pos ) 
-      = (bnumber) exp( var_getnval( &( argv[ 0 ] ) ) );
+      = (bnumber) exp( (double) var_getnval( &( argv[ 0 ] ) ) );
 
    return &nvar;
    }
@@ -1030,7 +1043,9 @@ fnc_val( argc, argv, unique_id )
       {
       init = TRUE;
       var_make( &nvar, NUMBER );
-      if ( ( tbuf = calloc( MAXSTRINGSIZE + 1, sizeof( char ) )) == NULL )
+
+      /* Revised to CALLOC pass-thru call by JBV */
+      if ( ( tbuf = CALLOC( MAXSTRINGSIZE + 1, sizeof( char ), "fnc_val" )) == NULL )
          {
 #if PROG_ERRORS
          bwb_error( "in fnc_val(): failed to get memory for tbuf" );
@@ -1078,6 +1093,9 @@ fnc_val( argc, argv, unique_id )
    /* read the value */
 
    str_btoc( tbuf, var_getsval( &( argv[ 0 ] ) ));
+   if ( strlen( tbuf ) == 0 ) /* JBV */
+      *var_findnval( &nvar, nvar.array_pos ) = (bnumber) 0;
+   else
 #if NUMBER_DOUBLE
    sscanf( tbuf, "%lf",
        var_findnval( &nvar, nvar.array_pos ) );
@@ -1122,7 +1140,9 @@ fnc_str( argc, argv, unique_id )
       {
       init = TRUE;
       var_make( &nvar, STRING );
-      if ( ( tbuf = calloc( MAXSTRINGSIZE + 1, sizeof( char ) )) == NULL )
+
+      /* Revised to CALLOC pass-thru call by JBV */
+      if ( ( tbuf = CALLOC( MAXSTRINGSIZE + 1, sizeof( char ), "fnc_str" )) == NULL )
          {
 #if PROG_ERRORS
          bwb_error( "in fnc_str(): failed to get memory for tbuf" );
@@ -1203,7 +1223,9 @@ fnc_hex( argc, argv, unique_id )
       {
       init = TRUE;
       var_make( &nvar, STRING );
-      if ( ( tbuf = calloc( MAXSTRINGSIZE + 1, sizeof( char ) )) == NULL )
+
+      /* Revised to CALLOC pass-thru call by JBV */
+      if ( ( tbuf = CALLOC( MAXSTRINGSIZE + 1, sizeof( char ), "fnc_hex" )) == NULL )
          {
 #if PROG_ERRORS
          bwb_error( "in fnc_hex(): failed to get memory for tbuf" );
@@ -1278,7 +1300,9 @@ fnc_oct( argc, argv, unique_id )
       {
       init = TRUE;
       var_make( &nvar, STRING );
-      if ( ( tbuf = calloc( MAXSTRINGSIZE + 1, sizeof( char ) )) == NULL )
+
+      /* Revised to CALLOC pass-thru call by JBV */
+      if ( ( tbuf = CALLOC( MAXSTRINGSIZE + 1, sizeof( char ), "fnc_oct" )) == NULL )
          {
 #if PROG_ERRORS
          bwb_error( "in fnc_oct(): failed to get memory for tbuf" );
@@ -1314,7 +1338,9 @@ fnc_oct( argc, argv, unique_id )
 
    /* format as octal integer */
 
-   sprintf( tbuf, "%o", (int) var_getnval( &( argv[ 0 ] ) ) );
+   /* Revised by JBV */
+   /* sprintf( tbuf, "%o", (int) var_getnval( &( argv[ 0 ] ) ) ); */
+   sprintf( tbuf, "%o", (int) trnc_int( (bnumber) var_getnval( &( argv[ 0 ] )) ) );
    str_ctob( var_findsval( &nvar, nvar.array_pos ), tbuf );
    return &nvar;
    }
@@ -1388,6 +1414,7 @@ fnc_mki( argc, argv, unique_id  )
    for ( i = 0; i < sizeof( int ); ++i )
       {
       tbuf[ i ] = an_integer.the_chars[ i ];
+      tbuf[ i + 1 ] = '\0';
       }
    b = var_getsval( &nvar );
    b->length = sizeof( int );
@@ -1545,6 +1572,7 @@ fnc_mks( argc, argv, unique_id  )
    for ( i = 0; i < sizeof( float ); ++i )
       {
       tbuf[ i ] = a_float.the_chars[ i ];
+      tbuf[ i + 1 ] = '\0';
       }
    b = var_getsval( &nvar );
    b->length = sizeof( float );
@@ -1807,7 +1835,7 @@ fnc_cvs( argc, argv, unique_id  )
 	DESCRIPTION:    This C function implements the BASIC
 			function CSNG().  As implemented,
 			this is a pseudo-function, since
-			all bwBASIC numerial values have the
+			all bwBASIC numerical values have the
 			same precision.
 
 	SYNTAX:		CSNG( number )
@@ -1955,18 +1983,19 @@ trnc_int( x )
    bnumber x;
 #endif
    {
-   bnumber sign;
+   double sign; /* Was bnumber (JBV) */
 
    if ( x < (bnumber) 0.0 )
       {
-      sign = (bnumber) -1.0;
+      sign = (double) -1.0; /* Was bnumber (JBV) */
       }
    else
       {
-      sign = (bnumber) 1.0;
+      sign = (double) 1.0; /* Was bnumber (JBV) */
       }
 
-   return (bnumber) ( floor( fabs( x )) * sign );
+   /* Added double recast here (JBV) */
+   return (bnumber) ( floor( fabs( (double) x )) * sign );
    }
 
 /***************************************************************
@@ -1991,27 +2020,27 @@ round_int( x )
 
    if ( x < (bnumber) 0.00 )
       {
-      if ( (bnumber) fabs( (bnumber) floor( x ) - x ) < (bnumber) 0.500 )
+      /* Added double recasts here (JBV) */
+      if ( (bnumber) fabs( (bnumber) floor( (double) x ) - x ) < (bnumber) 0.500 )
 	 {
-	 return (bnumber) floor( x );
+	 return (bnumber) floor( (double) x );
 	 }
       else
 	 {
-	 return (bnumber) ceil( x );
+	 return (bnumber) ceil( (double) x );
 	 }
       }
    else
       {
-      if ( ( x - (bnumber) floor( x )) < (bnumber) 0.500 )
+      if ( ( x - (bnumber) floor( (double) x )) < (bnumber) 0.500 )
 	 {
-	 return (bnumber) floor( x );
+	 return (bnumber) floor( (double) x );
 	 }
       else
 	 {
-	 return (bnumber) ceil( x );
+	 return (bnumber) ceil( (double) x );
 	 }
       }
    }
 
 
-
\ No newline at end of file
